<template>
  <div class="plans">
    <!--header-->
    <div class="plans--header">
      <p class="title-h1">Liste des plans d’animation commercial</p>
      <a-button @click="showDrawer" class="ant-btn-purple">
        <template #icon><plus-outlined /></template>
        Nouveau plan
      </a-button>
    </div>
    <!--filters-->
    <plan-list-header />
    <table class="table table-plans">
      <thead>
        <tr class="table-header">
          <th
            class="table-header__item"
            v-for="column in columns"
            :key="column.key"
          >
            <div>
              <span>{{ column.title }}</span>
            </div>
          </th>
        </tr>
      </thead>
      <tbody>
        <template v-for="(value, key) in data" :key="key">
          <tr>
            <td class="table-row__separate caption-small">{{ key }}</td>
          </tr>
          <tr v-for="row in value" :key="row.id">
            <td class="table-row__item title-medium">
              <div class="table-row__item_name">
                <span
                  class="icon"
                  :style="{ backgroundColor: getStatusColor(row.statusId) }"
                >
                  <bar-chart-outlined
                    :style="{ fontSize: '20px', color: '#fff' }"
                  />
                </span>
                <span>{{ row.name }}</span>
              </div>
            </td>
            <td class="table-row__item">
              <div>
                {{ row.operationCount }}
              </div>
            </td>
            <td class="table-row__item">
              <div>{{ row.dateFrom }}</div>
            </td>
            <td class="table-row__item">
              <div>{{ row.dateTo }}</div>
            </td>
            <td class="table-row__item">
              <div class="table-row__item_status">
                <span
                  class="icon"
                  :style="{ backgroundColor: getStatusColor(row.statusId) }"
                >
                </span>
                <span :style="{ color: getStatusColor(row.statusId) }">
                  {{ row.status }}
                </span>
              </div>
            </td>
            <td class="table-row__item">
              <delete-outlined :style="{ 'font-size': '20px' }" />
            </td>
          </tr>
        </template>
      </tbody>
    </table>
    <create-plan-component :visible="visible" @on-close="onClose" />
  </div>
</template>

<script lang="ts" setup>
import {
  DeleteOutlined,
  PlusOutlined,
  BarChartOutlined,
} from '@ant-design/icons-vue';
import { ref } from 'vue';
import CreatePlanComponent from '@/modules/plans/components/CreatePlanComponent.vue';
import PlanListHeader from '@/modules/plans/components/PlanListHeader.vue';
import type { TColumns } from '@/shared/types/table';
import { STATUSES } from '@/shared/types/constants';
const visible = ref<boolean>(false);

const showDrawer = () => {
  visible.value = true;
};

const onClose = () => {
  visible.value = false;
};

const getStatusColor = (statusId: number) => STATUSES[statusId].color;

const columns: TColumns = [
  {
    key: 'name',
    title: 'Nom du plan',
  },
  {
    key: 'operationCount',
    title: 'Nb d’opérations',
  },
  {
    key: 'dateFrom',
    title: 'Début',
  },
  {
    key: 'dateTo',
    title: 'Fin',
  },
  {
    key: 'status',
    title: 'Statut',
  },
  {
    key: 'action',
    title: '',
  },
];
let data = {
  2022: [
    {
      id: 1,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      statusId: 1,
      action: '',
    },
    {
      id: 2,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      statusId: 2,
      action: '',
    },
    {
      id: 3,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      statusId: 3,
      action: '',
    },
  ],
  2021: [
    {
      id: 4,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      action: '',
      statusId: 2,
    },
    {
      id: 5,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      action: '',
      statusId: 3,
    },
    {
      id: 6,
      name: 'Programme de FID 2022',
      operationCount: '23 opérations',
      dateFrom: '12/03/2021',
      dateTo: '12/05/2021',
      status: 'A venir',
      action: '',
      statusId: 1,
    },
  ],
};
</script>
<script lang="ts">
export default {
  name: 'PlansIndex',
};
</script>
<style lang="scss" scoped>
.plans {
  &--header {
    display: flex;
    justify-content: space-between;
    align-items: center;
  }
}

.table-plans {
  margin-top: 30px;
}
</style>
<route>
{
  meta: {
    middleware: 'auth'
  },
}
</route>
